# Auther: Chris Debenham
# Date: 12 Jun 2002

# You can reach me on AIM as hybr1d8

# This plugin is written for GAIM 0.58. It should work on most versions from 0.12 and later

# This plugin connects to you lcdproc server and displays the list of online buddies on your lcd.
# For this to be useful you need lcdproc (http://lcdproc.omnipotent.net/) and an LCD

# Needed to talk to lcdproc
use IO::Socket;

# Some global stuff
$ver = GAIM::get_info(0);
$nam = GAIM::get_info(1);
$rver = 0.1;
$lcdhostname = "localhost";
$lcdport = 13666;
$text ="none yet";

GAIM::register("LCDproc output","$rver","goodbye","");

# Connect to lcdproc
$lcd = IO::Socket::INET->new(
			Proto           => "tcp",
			PeerAddr        => $lcdhostname,
			PeerPort        => $lcdport) || die "Cannot connect to LCDd\n";

# Setup screen for LCDd
print $lcd "hello\n";
$response=<$lcd>;
chomp $response;
$width=$response;
$width =~ s/^.* wid //;
$width =~ s/ .*$//;
$height=$response;
$height =~ s/^.* hgt //;
$height =~ s/ .*$//;
print $lcd "client_set -name gaim\n";
print $lcd "screen_add gaim\n";
print $lcd "screen_set gaim\n";
print $lcd "widget_add gaim title title\n";
print $lcd "widget_set gaim title \"Online Buddies\"\n";
print $lcd "widget_add gaim online scroller\n";
print $lcd "widget_set gaim online 1 2 ".$width." ".$height." v 5 \"".$text."\"\n";


# Call handler every 5 seconds
GAIM::add_timeout_handler(5, "update_lcd");

# Update the lcd if needed
sub update_lcd {
	$text2="";

	foreach $con (GAIM::get_info(1)) {
		foreach $user (GAIM::online_list($con)) {
			@user_info = GAIM::user_info($con,$user);
			$text2 .= pack("A$width",$user_info[1]." - ".GAIM::get_info(7,$con));
		}
	}

	# If list has changed then refresh screen
	if ($text ne $text2) {
		$text = $text2;
		print $lcd "widget_set gaim online 1 2 ".$width." ".$height." v 5 \"".$text."\"\n";
		print $lcd "screen_set gaim -priority 64";
	} else {
		print $lcd "screen_set gaim -priority 128";
	}

	GAIM::add_timeout_handler(5, "update_lcd");
}

sub goodbye { 
    $thanks = 
	("Thank you for using this GAIM/LCDproc plugin\nv. $rver\n - Chris Debenham");
  GAIM::print("Goodbye",$thanks);
}

